/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.Date;
import java.util.GregorianCalendar;
import org.exoplatform.faces.core.component.UIDateInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.organization.Query;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchUserForm.java,v 1.6 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UISearchUserForm extends UISimpleForm {

  public static final String SEARCH_USER = "searchUser";

  private UIStringInput username_ ;
  private UIStringInput fname_ ;
  private UIStringInput lname_ ;
  private UIStringInput email_ ;
  private UIDateInput fromDate_ ;
  private UIDateInput toDate_ ;

  public UISearchUserForm() {
    super("searchForm", "post", null) ;
    setId("UISearchUserForm");
    setClazz("UIAdvancedSearch");
    username_ = new UIStringInput("userName", "") ;
    fname_ = new UIStringInput("fname", "") ;
    lname_ = new UIStringInput("lname", "") ;
    email_ = new UIStringInput("email", "") ;
    fromDate_ = new UIDateInput("fromDate", new GregorianCalendar(2004, 0, 1).getTime()) ;
    toDate_ = new UIDateInput("toDate", new Date()) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.username}")).
        add(new ComponentCell(this, username_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.first-name}")).
        add(new ComponentCell(this, fname_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.last-name}")).
        add(new ComponentCell(this, lname_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.email}")).
        add(new ComponentCell(this, email_))) ;
    add(new Row().
        add(new LabelCell("#{UISearchUserForm.label.login-time}")).
        add(new ListComponentCell().
            add(this, fromDate_).
            add("#{UISearchUserForm.label.to}").
            add(this, toDate_))) ;
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton("#{UISearchUserForm.button.search}", SEARCH_USER)).
            add(new FormButton("#{UISearchUserForm.button.cancel}", CANCEL_ACTION)).
            addColspan("2").addAlign("center"))) ;
   
    addActionListener(SearchUserActionListener.class, SEARCH_USER) ;  
    addActionListener(CancelActionListener.class, CANCEL_ACTION );
  }

  static public class SearchUserActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
      UIListUser uiListUser = (UIListUser) uiForm.getSibling(UIListUser.class) ;
      Query query = new Query() ;
      query.setUserName(uiForm.username_.getValue()) ;
      query.setFirstName(uiForm.fname_.getValue()) ;
      query.setLastName(uiForm.lname_.getValue()) ;
      query.setEmail(uiForm.email_.getValue()) ;
      query.setFromLoginDate(uiForm.fromDate_.getValue()) ;
      query.setToLoginDate(uiForm.toDate_.getValue()) ;
    	uiListUser.search(query) ;
      uiForm.setRenderedSibling(UIListUser.class) ;
    }
  }

  static public class CancelActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
      uiForm.username_.setValue("") ;
      uiForm.fname_.setValue("") ;
      uiForm.lname_.setValue("") ;
      uiForm.email_.setValue("") ;
      //UIListUser uiListUser = (UIListUser) uiForm.getSibling(UIListUser.class) ;
      uiForm.setRenderedSibling(UIListUser.class) ;
    }
  }
}